#### Beyond Linux® From Scratch (systemd Edition) - Version 10.1

### Chapter 46. Printing

- Prev

  Cups-2.3.3

- Next

  ghostscript-9.53.3

- Up
- Home

# cups-filters-1.28.7

## Introduction to CUPS Filters

The CUPS Filters package contains backends, filters and other software that was once part of the core CUPS distribution but is no longer maintained by Apple Inc.

This package is known to build and work properly using an LFS-10.1 platform.

### Package Information

- Download (HTTP): https://www.openprinting.org/download/cups-filters/cups-filters-1.28.7.tar.xz

- Download MD5 sum: 2efeed97e11ea5e157c5f4f2e0780fe7

- Download size: 1.4 MB

- Estimated disk space required: 60 MB (with tests), 17 MB installed

- Estimated build time: 0.4 SBU (with tests)

### CUPS Filters Dependencies

#### Required

Cups-2.3.3, GLib-2.66.7, ghostscript-9.53.3, Little CMS-2.12, Poppler-21.02.0, and Qpdf-10.1.0

#### Recommended

Dejavu fonts (the build fails if they are not installed, although they are only required for the tests), libjpeg-turbo-2.0.6, libpng-1.6.37, LibTIFF-4.2.0, and mupdf-1.18.0 (mutool)

#### Optional

Avahi-0.8 (required to build the DNSSD backend of the cups-browsed daemon, which is needed for operating some network printers), OpenLDAP-2.4.57, PHP-8.0.2 (use of this might be broken), Liblouis (Braille), and Liblouisutdml (Braille)

#### Optional printer drivers (runtime)

Gutenprint-5.3.3 (for supported printers), or other printer drivers, such as hplip

User Notes: http://wiki.linuxfromscratch.org/blfs/wiki/cups-filters

## Installation of CUPS Filters

First, fix the systemd unit file to work with CUPS 2.0 and later:

    sed -i "s:cups.service:org.cups.cupsd.service:g" utils/cups-browsed.service

Install CUPS Filters by running the following commands:

    ./configure --prefix=/usr        \
                --sysconfdir=/etc    \
                --localstatedir=/var \
                --without-rcdir      \
                --disable-static     \
                --disable-avahi      \
                --docdir=/usr/share/doc/cups-filters-1.28.7 &&
    make

To test the results, issue: make check. DejaVu fonts are needed for the tests.

Now, as the `root` user:

    make install

Install the systemd unit by running the following command as the `root` user:

    install -v -m644 utils/cups-browsed.service /lib/systemd/system/cups-browsed.service

## Command Explanations

`--disable-avahi`: This switch is needed if the optional Avahi-0.8 is not installed. Remove it if avahi is installed and you need network printer discovery capabilities.

`--without-rcdir`: This switch disables installation of the bundled bootscript which is not compatible with BLFS.

`--disable-static`: This switch prevents installation of static versions of the libraries.

`--with-test-font-path=`VALUE``: If you wish to run the tests, but you do not have the default `/usr/share/fonts/dejavu/DejaVuSans.ttf` use this switch to specify where `DejaVuSans.ttf` (or perhaps some other text TTF font - untested) is located.

## Configuring CUPS Filters

###

#### Systemd Units

To start the cups-browsed daemon at boot, enable the previously installed systemd unit by running the following command as the `root` user:

    systemctl enable cups-browsed

## Contents

Installed Programs: cups-browsed, driverless, driverless-fax, foomatic-rip, and ttfread
Installed Libraries: libcupsfilters.so and libfontembed.so
Installed Directories: /usr/include/{cupsfilters,fontembed}, /usr/lib/cups/{backend,driver,filter}, /usr/share/cups/{braille,charsets}, /usr/share/doc/cups-filters-1.28.7, and /usr/share/ppd/cupsfilters

### Short Descriptions

cups-browsed | is a daemon for browsing the Bonjour and CUPS broadcasts of shared, remote CUPS printers
driverless | is a PPD generator utility for driverless printing
driverless-fax | is a wrapper to driverless for FAX type devices
foomatic-rip | is a universal print filter/RIP wrapper which can be used as CUPS filter or stand-alone for spooler-less, direct printing
`libcupsfilters.so` | contains CUPS Filters API functions

Last updated on 2021-02-21 20:38:24 -0800

- Prev

  Cups-2.3.3

- Next

  ghostscript-9.53.3

- Up
- Home